/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Vue;

import BluetoothJavaServer.src.edu.kufpg.bluetooth.server.BluetoothManager;
import BluetoothJavaServer.src.edu.kufpg.bluetooth.server.BluetoothThread;
import java.net.URL;
import java.util.ResourceBundle;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.HBox;

/**
 * FXML Controller class
 *
 * @author invite
 */
public class FXMLVueController implements Initializable {

    @FXML
    private GridPane accueil;
    @FXML
    private Label temperature;
    @FXML
    private Label intensity;
    @FXML
    private Label himidityAir;
    @FXML
    private Label humidityPlante;
    @FXML
    private Label humiditySeuil;
    @FXML
    private HBox alertMessage;
    
    @FXML
    private GridPane configuration;
    @FXML
    private TextField seuil;
    @FXML
    private Label seuilError;
    @FXML
    private CheckBox arrosageAuto;
    
    private GridPane currentGridPane;
    private Button currentButton;
    
    
    @FXML
    private Button buttonAccueil;
    @FXML
    private Button buttonConfig;

    private boolean isConnected = false;
    /**
     * Initializes the controller class.
     */
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        
        /**
        BluetoothManager bluetoothManager = new BluetoothManager(this);
        bluetoothManager.launch();
        
        try {
            bluetoothManager.startThread();
        } catch (Exception ex) {
            Logger.getLogger(FXMLVueController.class.getName()).log(Level.SEVERE, null, ex);
        }     
        **/
        
        //Put the gridPane Accueil visible
        accueil.setVisible(true);
        currentGridPane = accueil;
        currentButton = buttonAccueil;
        currentButton.setStyle("-fx-background-color: #7fca5eff");
        
        alertMessage.setVisible(false);
        //Only allow integers as a value for the seuil
        seuil.textProperty().addListener(new ChangeListener<String>() {
            @Override
            public void changed(ObservableValue<? extends String> observable, String oldValue, String newValue) {
                if (!newValue.matches("\\d*")) {
                    seuil.setText(newValue.replaceAll("[^\\d]", ""));
                }
                seuilError.setText("");
                if (!(seuil.getText().isEmpty()) && !(Integer.parseInt(seuil.getText())<100)){
                    seuilError.setText("La valeur du seuil doit être inférieure à 100%");
                }
            }
        });
        //Bind the label for the seuil in Accueil and the value in configurations
        humiditySeuil.textProperty().bind(seuil.textProperty());
    }    

    /**
     * Change the page for the accueil page when clicking on accueil button
     * @param event 
     */
    @FXML
    private void clickAccueil(ActionEvent event) {
        currentGridPane.setVisible(false);
        accueil.setVisible(true);
        currentGridPane = accueil;
        currentButton.setStyle("-fx-background-color: #d5d5d5ff");
        currentButton = buttonAccueil;
        currentButton.setStyle("-fx-background-color: #7fca5eff");
    }

    /**
     * Change the page for the configuration page when clicking on configuration button
     * @param event 
     */
    @FXML
    private void clickConfig(ActionEvent event) {
        currentGridPane.setVisible(false);
        configuration.setVisible(true);
        currentGridPane = configuration;
        currentButton.setStyle("-fx-background-color: #d5d5d5ff");
        currentButton = buttonConfig;
        currentButton.setStyle("-fx-background-color: #7fca5eff");
    }

    /**
     * Change the text for activate or desactivate according to the checkbox
     * @param event 
     */
    @FXML
    private void clickAuto(ActionEvent event) {
        if(arrosageAuto.isSelected()){
            arrosageAuto.setText("Activé");
        }
        else arrosageAuto.setText("Désactivé");
    }
    
    public void update(BluetoothThread t){
        // MAJ LA VUE
        System.err.println(t.getBuffer());
    }
    
}
